import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react'
import styles from './index.module.scss'
import { Button, DatePicker, Input, Select } from 'antd'
import dayjs from 'dayjs'
import MyTable from '@/components/MyTable'
import { D6tableC, statusObj } from '@/utils/tableData'
import MyPopconfirm from '@/components/MyPopconfirm'
import history, { btnFlagFu } from '@/utils/history'
import { selectObj } from '@/utils/select'
import { D3baseFormData } from '../D4impStor'
import { useDispatch, useSelector } from 'react-redux'
import { D2_APIgetList } from '@/store/action/D2storSet'
import { RootState } from '@/store'
import { MessageFu } from '@/utils/message'
import { FourTableType } from '@/pages/B_enterTibet/B1collect/type'
import ExportJsonExcel from 'js-export-excel'
import { D6_APIdel, D6_APIgetList } from '@/store/action/D6putsStor'
import { B3_4inputKeyArr, D3InputKeyType } from '@/pages/B_enterTibet/B1collect/data'
const { RangePicker } = DatePicker

function D6putsStor() {
  const dispatch = useDispatch()

  // 获取出库库房下拉框 - 库房设置列表
  useEffect(() => {
    dispatch(D2_APIgetList({ pageNum: 1, pageSize: 99999 }))
  }, [dispatch])

  const { list } = useSelector((state: RootState) => state.D2storSet.tableInfo)

  const [formData, setFormData] = useState(D3baseFormData)
  const formDataRef = useRef(D3baseFormData)
  const formDataOldRef = useRef(D3baseFormData)

  useEffect(() => {
    formDataRef.current = formData
  }, [formData])

  // 点击搜索的 时间戳
  const [timeKey, setTimeKey] = useState(0)

  // 点击搜索
  const clickSearch = useCallback(() => {
    setFormData({ ...formData, pageNum: 1 })
    setTimeout(() => {
      setTimeKey(Date.now())
    }, 50)
  }, [formData])

  // 时间选择器改变
  const timeChange = useCallback(
    (date: any, dateString: any) => {
      let startTime = ''
      let endTime = ''
      if (dateString[0] && dateString[1]) {
        startTime = dateString[0] + ' 00:00:00'
        endTime = dateString[1] + ' 23:59:59'
      }
      setFormData({ ...formData, startTime, endTime })
    },
    [formData]
  )

  // 封装发送请求的函数
  const getListFu = useCallback(() => {
    formDataOldRef.current = { ...formDataRef.current }
    dispatch(D6_APIgetList(formDataRef.current))
  }, [dispatch])

  useEffect(() => {
    getListFu()
  }, [getListFu, timeKey])

  // 输入框的改变
  const txtChangeFu = useCallback(
    (txt: string, key: D3InputKeyType) => {
      setFormData({
        ...formData,
        [key]: txt
      })
    },
    [formData]
  )

  // 点击重置
  const resetSelectFu = useCallback(() => {
    setFormData(D3baseFormData)
    setTimeout(() => {
      setTimeKey(Date.now())
    }, 50)
  }, [])

  // 页码变化
  const paginationChange = useCallback(
    (pageNum: number, pageSize: number) => {
      setFormData({ ...formData, pageNum, pageSize })
      setTimeout(() => {
        setTimeKey(Date.now())
      }, 50)
    },
    [formData]
  )

  // 点击删除
  const delTableFu = useCallback(
    async (id: number) => {
      const res = await D6_APIdel(id)
      if (res.code === 0) {
        MessageFu.success('删除成功')
        getListFu()
      }
    },
    [getListFu]
  )

  // 点击操作按钮
  const tableBtnFu = useCallback((id: number, key: string) => {
    history.push(`/putsStor_edit/${key}/${id}`)
  }, [])

  const tableLastBtn = useMemo(() => {
    return [
      {
        title: '操作',
        render: (item: FourTableType) => {
          let obj = btnFlagFu(item)
          return !Object.values(obj).some(Boolean) ? (
            '-'
          ) : (
            <>
              {obj['编辑'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '2')}>
                  编辑
                </Button>
              ) : null}

              {obj['审批'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '3')}>
                  审批
                </Button>
              ) : null}
              {obj['查看'] ? (
                <Button size='small' type='text' onClick={() => tableBtnFu(item.id, '4')}>
                  查看
                </Button>
              ) : null}

              {obj['删除'] ? (
                <MyPopconfirm txtK='删除' onConfirm={() => delTableFu(item.id)} />
              ) : null}
            </>
          )
        }
      }
    ]
  }, [delTableFu, tableBtnFu])

  // 从仓库拿数据
  const tableInfo = useSelector((state: RootState) => state.D6putsStor.tableInfo)

  // 点击导出
  const deriveFu = useCallback(async () => {
    const name = '藏品出库' + dayjs(new Date()).format('YYYY-MM-DD HH:mm')

    const res = await D6_APIgetList(
      {
        ...formDataOldRef.current,
        pageNum: 1,
        pageSize: 99999
      },
      true
    )

    if (res.code === 0) {
      if (res.data.records.length <= 0) return MessageFu.warning('当前搜索条件没有数据!')

      const option = {
        fileName: name,
        datas: [
          {
            sheetData: res.data.records.map((v: FourTableType) => ({
              ...v,
              status: statusObj[v.status as 1],
              isReturn: v.isReturn === 1 ? '是' : '否',
              returnDate: v.returnDate || '（空）'
            })),
            sheetName: name,
            sheetFilter: [
              'num',
              'name',
              'storageName',
              'isReturn',
              'returnDate',
              'deptName',
              'creatorName',
              'createTime',
              'status'
            ],
            sheetHeader: [
              '业务单号',
              '申请名称',
              '入库库房',
              '是否需要归还',
              '预计归还日期',
              '发起部门',
              '发送人',
              '发起日期',
              '申请状态'
            ],
            columnWidths: [10, 10, 10, 10, 10, 10, 10, 10, 10]
          }
        ]
      }

      const toExcel = new ExportJsonExcel(option) //new
      toExcel.saveExcel() //保存
    }
  }, [])

  return (
    <div className={styles.D6putsStor}>
      <div className='pageTitle'>藏品出库</div>

      <div className='D4top'>
        <div className='D4topll'>
          {B3_4inputKeyArr.map(item => (
            <div key={item.name}>
              <span>{item.name}：</span>
              <Input
                placeholder={`请输入${item.name}`}
                maxLength={30}
                value={formData[item.key]}
                onChange={e => txtChangeFu(e.target.value, item.key)}
              />
            </div>
          ))}
        </div>
        <div className='D4toprr'>
          <Button type='primary' onClick={deriveFu}>
            批量导出
          </Button>
          &emsp;
          <Button type='primary' onClick={() => history.push('/putsStor_edit/1/null')}>
            新增
          </Button>
        </div>
      </div>
      <div className='D4top'>
        <div className='D4topll'>
          <div>
            <span>发起日期范围：</span>
            <RangePicker
              value={
                formData.startTime ? [dayjs(formData.startTime), dayjs(formData.endTime)] : null
              }
              onChange={timeChange}
            />
          </div>

          <div>
            <span>申请状态：</span>
            <Select
              allowClear={true}
              placeholder='全部'
              style={{ width: 150 }}
              value={formData.status}
              onChange={e => setFormData({ ...formData, status: e })}
              options={selectObj['申请状态'].filter(v => v.label !== '待盘点')}
            />
          </div>

          <div>
            <span>选择角色：</span>
            <Select
              allowClear={true}
              style={{ width: 150 }}
              placeholder='全部'
              options={selectObj['角色']}
              // fieldNames={{ value: 'id', label: 'roleName' }}
              value={formData.userType}
              onChange={e => setFormData({ ...formData, userType: e })}
            />
          </div>

          <div>
            <span>出库库房：</span>
            {/* 拿库房设置的列表 */}
            <Select
              allowClear={true}
              placeholder='全部'
              style={{ width: 150 }}
              value={formData.storageInId}
              onChange={e => setFormData({ ...formData, storageInId: e })}
              fieldNames={{ value: 'id', label: 'name' }}
              options={list}
            />
          </div>
        </div>
        <div className='D4toprr'>
          <Button type='primary' onClick={clickSearch}>
            查询
          </Button>
          &emsp;<Button onClick={resetSelectFu}>重置</Button>
        </div>
      </div>

      {/* 表格 */}
      <MyTable
        yHeight={610}
        list={tableInfo.list}
        columnsTemp={D6tableC}
        lastBtn={tableLastBtn}
        pageNum={formData.pageNum}
        pageSize={formData.pageSize}
        total={tableInfo.total}
        onChange={(pageNum, pageSize) => paginationChange(pageNum, pageSize)}
      />
    </div>
  )
}

const MemoD6putsStor = React.memo(D6putsStor)

export default MemoD6putsStor
